package com.matrix.form.admin.logon.filter;

import com.matrix.api.identity.MFUser;
import com.matrix.app.MAppContext;
import com.matrix.app.MAppProperties;
import com.matrix.commonservice.data.DataService;
import com.matrix.extention.SessionContextHelper;
import com.matrix.form.admin.cloud.service.MApplicationService;
import com.matrix.form.admin.logon.filter.UserLoginHelper;
import com.matrix.form.api.MFormContext;
import com.matrix.form.util.CommonUtil;
import com.matrix.form.web.listener.SessionContextHolder;
import com.matrix.sso.SSOProperties;
import java.io.IOException;
import java.net.URLEncoder;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.http.Cookie;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import org.apache.commons.lang.StringUtils;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.springframework.util.AntPathMatcher;

public class UserLogonFilter implements Filter {

   private static final Log log = LogFactory.getLog("MatrixLogic");
   private String excludedPages;
   private String[] excludedPageArray;


   public void destroy() {
   }

   public void doFilter(ServletRequest request, ServletResponse response, FilterChain chain) throws IOException, ServletException {
      HttpServletRequest httpRequest = (HttpServletRequest)request;
      HttpServletResponse httpResponse = (HttpServletResponse)response;
      MFormContext.setSessionAttribute("skin", "primary");
      boolean isExcludedPage = false;
      String code;
      if(this.excludedPageArray != null) {
         String[] configCodeKey = this.excludedPageArray;
         int codeKey = this.excludedPageArray.length;

         for(int identityMgr = 0; identityMgr < codeKey; ++identityMgr) {
            String httpSession = configCodeKey[identityMgr];
            code = httpRequest.getRequestURI();
            AntPathMatcher logonPage = new AntPathMatcher();
            if(logonPage.match(httpSession, code)) {
               isExcludedPage = true;
               break;
            }
         }
      }

      if(isExcludedPage) {
         chain.doFilter(request, response);
      } else {
         SessionContextHelper.setRequest(httpRequest);
         HttpSession var29 = httpRequest.getSession();
         MFUser var30 = MFormContext.getUser();
         String var31 = "code";
         String var32 = SSOProperties.getInstance().getCodeKey();
         if(StringUtils.isNotBlank(var32)) {
            var31 = var32;
         }

         code = request.getParameter(var31);
         if(var30 == null && MFormContext.getFormProperties().isSSOFlag() && StringUtils.isNotBlank(code)) {
            UserLoginHelper var33 = new UserLoginHelper();
            var30 = var33.login(code);
            if(var30 != null) {
               this.initFunctionsOfUser(httpRequest, var30);
               httpRequest.setAttribute("userName", var30.getUserName());
               SessionContextHolder.getSession().removeAttribute("EnterAppFlag");
            }
         }

         String var34 = "/form/admin/logon/matrix/logon.jsp";
         if(CommonUtil.isMatrix()) {
            if(MAppProperties.getInstance().isTenantEnable()) {
               var34 = "/appLogon.html";
            } else {
               var34 = "/form/admin/logon/matrix/logon-bpm.jsp";
            }
         }

         boolean ssoFlag = MFormContext.getFormProperties().isSSOFlag();
         String e;
         if(var30 == null && ssoFlag) {
            log.debug("ssoFlag = true, redirect to sso...");
            e = MFormContext.getFormProperties().getIndexURL();
            String authFlag = "";
            String appService;
            String isAppAdmin;
            String encodePath;
            String ssoFullUrl;
            String var41;
            if(StringUtils.isNotBlank(e)) {
               authFlag = e;
            } else {
               Map totalRoleIds = httpRequest.getParameterMap();
               authFlag = httpRequest.getRequestURL().toString();
               log.debug("requestPath:" + authFlag);
               appService = SSOProperties.getInstance().getBizDomain();
               if(appService != null && appService.trim().length() > 0) {
                  isAppAdmin = httpRequest.getContextPath();
                  authFlag = "https://" + appService + "/" + isAppAdmin + "/index.jsp";
               } else {
                  isAppAdmin = SSOProperties.getInstance().getHttpValue();
                  if("https".equals(isAppAdmin)) {
                     if(!authFlag.startsWith("https")) {
                        authFlag = authFlag.replaceAll("http", "https");
                     }
                  } else if("http".equals(isAppAdmin) && authFlag.startsWith("https")) {
                     authFlag = authFlag.replaceAll("https", "http");
                  }
               }

               log.debug("mapping requestPath:" + authFlag);
               StringBuffer var40 = new StringBuffer();
               Iterator authorize = totalRoleIds.keySet().iterator();

               while(authorize.hasNext()) {
                  encodePath = (String)authorize.next();
                  ssoFullUrl = httpRequest.getParameter(encodePath);
                  if(var40.length() > 0) {
                     var40.append("&");
                  }

                  var40.append(encodePath);
                  var40.append("=");
                  if(ssoFullUrl != null) {
                     var40.append(ssoFullUrl);
                  }
               }

               var41 = request.getParameter("language");
               var41 = "zh-CN";
               if(authFlag.indexOf("?") > 0) {
                  authFlag = authFlag + "&" + var40.toString() + "&mFirstLogin=true&language=" + var41;
               } else {
                  authFlag = authFlag + "?" + var40.toString() + "&mFirstLogin=true&language=" + var41;
               }
            }

            log.debug("real requestPath:" + authFlag);
            String var35 = SSOProperties.getInstance().getBamDomain();
            appService = SSOProperties.getInstance().getClientId();
            isAppAdmin = SSOProperties.getInstance().getServerIP();
            var41 = SSOProperties.getInstance().getAuthorize();
            encodePath = URLEncoder.encode(authFlag);
            ssoFullUrl = SSOProperties.getInstance().getSsoFullUrl();
            String url = null;
            if(StringUtils.isNotBlank(ssoFullUrl)) {
               ssoFullUrl = ssoFullUrl.replace("{bamDomain}", var35);
               ssoFullUrl = ssoFullUrl.replace("{clientId}", appService);
               ssoFullUrl = ssoFullUrl.replace("{authorize}", var41);
               ssoFullUrl = ssoFullUrl.replace("{redirectUri}", authFlag);
               ssoFullUrl = ssoFullUrl.replace("{encodePath}", encodePath);
               url = ssoFullUrl;
            } else {
               if(StringUtils.isBlank(var41)) {
                  var41 = "/idp/oauth2/authorize";
               }

               if(var41 != null && !var41.startsWith("/")) {
                  var41 = "/" + var41;
               }

               url = "https://" + var35 + var41 + "?client_id=" + appService + "&redirect_uri=" + encodePath + "&response_type=code&scope=userinfo&state=123456";
            }

            String mUserId = request.getParameter("mUserId");
            if(mUserId == null || mUserId.trim().length() <= 0) {
               log.debug("redirect url is:" + url);
               httpResponse.sendRedirect(url);
               return;
            }

            UserLoginHelper helper = new UserLoginHelper();
            DataService dataService = (DataService)MFormContext.getService("DataService");
            String sql = "SELECT LOGON_NAME,PASSWORD FROM MF_ORG_USER where USER_ID = ? ";
            List userInfos = dataService.querySqlList(sql, new Object[]{mUserId}, (String)null);
            if(userInfos == null || userInfos.size() == 0) {
               return;
            }

            var30 = helper.signonByUserId(mUserId);
            if(var30 != null && !com.matrix.form.admin.common.utils.CommonUtil.isAdmin()) {
               var30 = null;
            }
         }

         try {
            if(var30 == null) {
               if(httpRequest.getRequestURI().indexOf("/ImageServlet") == -1 && !httpRequest.getRequestURI().endsWith("/logout.html") && httpRequest.getParameter("logonName") == null && (!httpRequest.getRequestURI().endsWith("/appLogon.html") || !MAppProperties.getInstance().isTenantEnable()) && !httpRequest.getRequestURI().endsWith("/logon_logon.action") && !httpRequest.getRequestURI().endsWith("/auth_logon.action")) {
                  if("true".equals(var29.getAttribute("matrix_logoff_flag"))) {
                     var29.removeAttribute("matrix_logoff_flag");
                     return;
                  }

                  httpRequest.setCharacterEncoding("UTF-8");
                  if(this.isAjaxRequest(httpRequest)) {
                     httpResponse.setStatus(5000);
                     httpResponse.addHeader("matrixstatus", "Timeout");
                     if(this.isMobile(request)) {
                        httpResponse.addHeader("matrixurl", httpRequest.getContextPath() + var34 + "?" + "m_appId" + httpRequest.getParameter("m_appId"));
                     } else {
                        httpResponse.addHeader("matrixurl", httpRequest.getContextPath() + var34 + "?" + "m_appId" + CommonUtil.getCookie(httpRequest, "m_appId"));
                     }
                  } else {
                     httpResponse.sendRedirect(httpRequest.getContextPath() + var34);
                  }

                  return;
               }
            } else {
               if(httpRequest.getContextPath() != null && !"".equals(httpRequest.getContextPath()) && (httpRequest.getRequestURI().endsWith(httpRequest.getContextPath()) || httpRequest.getRequestURI().endsWith(httpRequest.getContextPath() + "/"))) {
                  if(ssoFlag && "/mpaas/".equals(httpRequest.getRequestURI())) {
                     if(MAppProperties.getInstance().isTenantEnable()) {
                        httpResponse.sendRedirect(httpRequest.getContextPath() + "/form/admin/cloud/appIndex.html");
                     } else {
                        httpResponse.sendRedirect(httpRequest.getContextPath() + var34);
                     }
                  } else {
                     httpResponse.sendRedirect(httpRequest.getContextPath() + var34);
                  }

                  return;
               }

               e = MAppContext.getCurrentAppId();
               boolean var39 = false;
               if(e == null && e.trim().length() <= 0) {
                  var39 = true;
               } else {
                  List var36 = var30.getTotalRoleIds();
                  boolean var42;
                  if("root".equals(e)) {
                     boolean var37 = com.matrix.form.admin.common.utils.CommonUtil.isSysAdmin();
                     var42 = com.matrix.form.admin.common.utils.CommonUtil.isDesigner();
                     if(var37 || var42) {
                        var39 = true;
                     }
                  } else {
                     MApplicationService var38 = (MApplicationService)MFormContext.getService("MApplicationServiceImpl");
                     var42 = var38.isAppAdmin(e);
                     if(var42) {
                        var39 = true;
                     }
                  }
               }

               if(!var39 && !httpRequest.getRequestURI().endsWith("appLogon.html") && !httpRequest.getRequestURI().endsWith("appIndex.html")) {
                  return;
               }
            }
         } catch (Exception var28) {
            var28.printStackTrace();
         }

         httpResponse.setHeader("Pragma", "No-cache");
         httpResponse.setHeader("Cache-Control", "no-cache");
         httpResponse.setDateHeader("Expires", 0L);
         if(chain != null) {
            this.setCurrentLanggeCookie(var29, httpResponse);
            chain.doFilter(request, response);
         }

      }
   }

   private boolean isAjaxRequest(ServletRequest request) {
      boolean isAjax = false;
      String ajaxValue = request.getParameter("X-Requested-With");
      if(ajaxValue != null && "XMLHttpRequest".equals(ajaxValue)) {
         isAjax = true;
      }

      return isAjax;
   }

   private void initFunctionsOfUser(HttpServletRequest httpRequest, MFUser user) {
      if(user != null) {
         ArrayList items = new ArrayList();
         List roles = user.getRoleIds();
         String adminSec = MFormContext.getFormProperties().getAdminSec();
         if(adminSec != null && adminSec.trim().length() != 0 && !roles.contains(adminSec)) {
            String developmentSec;
            if("matrix".equals(com.matrix.form.admin.common.utils.CommonUtil.getFormUser())) {
               developmentSec = MFormContext.getFormProperties().getRequirementSec();
               if(developmentSec != null && developmentSec.trim().length() > 0 && roles.contains(developmentSec)) {
                  items.add("\"requirement\"");
               }
            } else if("zr".equals(com.matrix.form.admin.common.utils.CommonUtil.getFormUser())) {
               developmentSec = MFormContext.getFormProperties().getImplementSec();
               if(developmentSec != null && developmentSec.trim().length() > 0 && roles.contains(developmentSec)) {
                  items.add("\"implement\"");
               }
            }

            developmentSec = MFormContext.getFormProperties().getDevelopmentSec();
            if(developmentSec != null && developmentSec.trim().length() > 0 && roles.contains(developmentSec)) {
               if("matrix".equals(com.matrix.form.admin.common.utils.CommonUtil.getFormUser())) {
                  items.add("\"implement\"");
               } else if("zr".equals(com.matrix.form.admin.common.utils.CommonUtil.getFormUser())) {
                  items.add("\"development\"");
               }
            }

            String businessSec = MFormContext.getFormProperties().getBusinessSec();
            if(businessSec != null && businessSec.trim().length() > 0 && roles.contains(businessSec)) {
               items.add("\"customize\"");
            }
         } else {
            if("matrix".equals(com.matrix.form.admin.common.utils.CommonUtil.getFormUser())) {
               items.add("\"requirement\"");
               items.add("\"insMgr\"");
            } else if("zr".equals(com.matrix.form.admin.common.utils.CommonUtil.getFormUser())) {
               items.add("\"development\"");
            }

            items.add("\"implement\"");
            items.add("\"customize\"");
            items.add("\"sysMgr\"");
         }

         httpRequest.setAttribute("mfunctions", items.toString());
      }
   }

   private boolean isMobile(ServletRequest request) {
      String agent = ((HttpServletRequest)request).getHeader("USER-AGENT");
      if(agent == null) {
         return false;
      } else {
         String userAgent = agent.toLowerCase();
         return userAgent.indexOf("iphone") > 0 || userAgent.indexOf("mobile") > 0;
      }
   }

   private boolean containPath(String path, String urlPattern) {
      int index = urlPattern.indexOf("*");
      if(index >= 0) {
         String pian = urlPattern.substring(0, index);
         if(path.startsWith(pian)) {
            return true;
         }
      } else if(path.equals(urlPattern)) {
         return true;
      }

      return false;
   }

   public void init(FilterConfig filterConfig) throws ServletException {
      this.excludedPages = filterConfig.getInitParameter("excludedPages");
      if(this.excludedPages != null && this.excludedPages.trim().length() > 0) {
         this.excludedPageArray = this.excludedPages.split(",");
      }

   }

   private void setCurrentLanggeCookie(HttpSession httpSession, HttpServletResponse httpResponse) {
      String langge = (String)httpSession.getAttribute("langge");
      if(langge != null && langge.trim().length() > 0) {
         Cookie cookie = new Cookie("langge", langge);
         cookie.setPath("/");
         httpResponse.addCookie(cookie);
      }

   }
}
